#include "p79.h"

#include <sys/types.h>
#include <sys/times.h>
#include <sys/param.h>

#ifndef HZ
#ifdef AHZ
#define HZ AHZ				/* NeXT (CMU MACH O/S) uses AHZ */
#else
#define HZ 60
#endif
#endif

double
FORTRAN(p79sec,P79SEC)()
{
    struct tms	buffer;
    double	system_time;
    double	user_time;

    (void) times(&buffer);
    user_time = ((double)buffer.tms_utime) / (double) (HZ);
    system_time = ((double)buffer.tms_stime) / (double) (HZ);

    return (user_time + system_time);
}
