      SUBROUTINE  SFTRN3
C     (SFTRN3)
C     EWM  SFTRN3:  'DO' analysis
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       ADDBUF,      ATPENO,      ATTNOF,      CLOGNX
C     EXTERNAL REFS       CNAMNX,      DCODE,       F4CLC,       F4MVC
C     EXTERNAL REFS       GCALPR,      GIFLOG,      GIFNLG,      GOTOS2
C     EXTERNAL REFS       IOFUNC,      ISIGN,       NCODE,       OPNCNT
C     EXTERNAL REFS       OSFLST,      PARENS,      SCANER,      SFTERR
C     EXTERNAL REFS       SRSTAK
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             DCODE,       F4CLC,       PARENS,      SCANER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             ISIGN
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                COMNT,       DOTYPE,      I,           LJUNK
C     SETS                LN1,         LN2,         LN3,         LNMBR
C     SETS                MAX,         N,           N1LIT,       N2LIT
C     SETS                N3LIT,       N3VALU,      NSSAVE
C
      INTEGER             DOTYPE,      I,           LN1,         LN2
      INTEGER             LN3,         LNMBR,       MAX,         N
      INTEGER             N1VALU,      N2VALU,      N3VALU,      NCASES
      INTEGER             NSSAVE,      NXXXS2(6)
      LOGICAL             COMNT,       LJUNK,       N1LIT,       N2LIT
      LOGICAL             N3LIT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM02  /
C
      INTEGER             CCFLGS,      CCLIST,      CCNAME,      CCRW
      INTEGER             DEFNO,       INDEXS,      LFLGS,       LLIST
      INTEGER             LLOGS,       MAXLEV,      NEXT
C
      COMMON / COM02  /   CCFLGS(2),   CCLIST,      CCNAME,      CCRW
      COMMON / COM02  /   DEFNO,       INDEXS(38,39)
      COMMON / COM02  /   LFLGS(2),    LLIST,       LLOGS(2)
      COMMON / COM02  /   MAXLEV,      NEXT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM08  /
C
      LOGICAL             CYCLES
C
      COMMON / COM08  /   CYCLES(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM09  /
C
      INTEGER             CCN1,        CCN2,        CCN3,        CCNMBR
C
      COMMON / COM09  /   CCN1,        CCN2,        CCN3,        CCNMBR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM11  /
C
      INTEGER             COMCHR,      LCCHR
C
      COMMON / COM11  /   COMCHR(1),   LCCHR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM24  /
C
      INTEGER             FIND,        LOCATE,      SCAN
C
      COMMON / COM24  /   FIND,        LOCATE,      SCAN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM25  /
C
      INTEGER             DEFINE,      DOCASE,      DOFOR,       DOWITH
      INTEGER             ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      INTEGER             ONCE,        PROC,        UNTIL,       WHILE
C
      COMMON / COM25  /   DEFINE,      DOCASE,      DOFOR,       DOWITH
      COMMON / COM25  /   ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      COMMON / COM25  /   ONCE,        PROC,        UNTIL,       WHILE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM30  /
C
      INTEGER             NB,          BUFFER
C
      COMMON / COM30  /   NB,          BUFFER(1326)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
      FND=.FALSE.
      DOTYPE=0
      GO TO 20002
20001 IF (FND .OR. DOTYPE.EQ.8) GO TO 20003
20002 DOTYPE=DOTYPE+1
      NX0012=DOTYPE
      IF (NX0012.LT.1.OR.NX0012.GT.8) GO TO 20012
      GO TO (20004,20005,20006,20007,20008,20009,20010,20011), NX0012
20004 IF (.NOT.(SCANER (FIND,5HWHILE,5))) GO TO 20014
      ASSIGN 20014 TO NPR001
      GO TO 30001
20014 GO TO 20013
20005 IF (.NOT.(SCANER (FIND,5HUNTIL,5))) GO TO 20015
      ASSIGN 20015 TO NPR002
      GO TO 30002
20015 GO TO 20013
20006 IF (.NOT.(SCANER (FIND,4HWITH,4))) GO TO 20016
      ASSIGN 20016 TO NPR003
      GO TO 30003
20016 GO TO 20013
20007 ASSIGN 20017 TO NPR004
      GO TO 30004
20017 IF (.NOT.(FND)) GO TO 20018
      ASSIGN 20018 TO NPR005
      GO TO 30005
20018 GO TO 20013
20008 IF (.NOT.(SCANER (FIND,7HFOREVER,7))) GO TO 20019
      ASSIGN 20022 TO NPR006
      GO TO 30006
20022 GO TO 20020
20019 IF (.NOT.(SCANER (FIND,3HFOR,3))) GO TO 20023
      ASSIGN 20023 TO NPR007
      GO TO 30007
20023 CONTINUE
20020 CONTINUE
20021 GO TO 20013
20009 IF (.NOT.(SCANER (FIND,4HCASE,4))) GO TO 20024
      ASSIGN 20024 TO NPR008
      GO TO 30008
20024 GO TO 20013
20010 IF (.NOT.(SCANER (FIND,4HONCE,4))) GO TO 20025
      ASSIGN 20025 TO NPR009
      GO TO 30009
20025 GO TO 20013
20011 IF (.NOT.(SCANER (FIND,5HBLOCK,5))) GO TO 20026
      ASSIGN 20026 TO NPR009
      GO TO 30009
20026 CONTINUE
20012 CONTINUE
20013 GO TO 20001
20003 FOUND=.TRUE.
C
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Attach Number to Generated FORTRAN Statement)
30010 CALL ATTNOF
      GO TO NPR010, (20109,20116)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Attach Pending Number, if any, to Generated Statement)
30011 CALL ATPENO
      GO TO NPR011, (20097,20098,20099)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for '(INDEX,NCASES)' Next)
30012 FND=PARENS(STMT,CCMORE,NS,LEFT,RIGHT)
      IF (.NOT.(FND)) GO TO 20027
      CCINDX=LEFT+1
      CCMORE=CCINDX
      FND=SCANER (LOCATE,1H,,1)
      IF (.NOT.(FND)) GO TO 20030
      LINDX=CC-CCINDX
      CCNMBR=CCMORE
      LNMBR=RIGHT-CCNMBR
      FND=DCODE(STMT,CCMORE,RIGHT-1,NCASES)
      FND=FND .AND. NCASES.GT.0
      LJUNK = SCANER (SCAN,STMT,RIGHT+1)
20030 CONTINUE
20027 GO TO 20033
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for '(LOGIC)' Next)
30013 CALL CLOGNX
      GO TO NPR013, (20074,20082)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for '(NAME)' Next)
30004 CALL CNAMNX
      GO TO 20017
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-CASE)
30008 ASSIGN 20033 TO NPR012
      GO TO 30012
20033 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20034
      ASSIGN 20037 TO NPR014
      GO TO 30014
20037 S2=S0+NCASES+1
      ASSIGN 20038 TO NPR015
      GO TO 30015
20038 ASSIGN 20039 TO NPR016
      GO TO 30016
20039 S1=S0+1
      S2=S0+NCASES
      ASSIGN 20040 TO NPR017
      GO TO 30017
20040 IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      STRCTS(LEVEL)=DOCASE
      S1STAK(LEVEL)=S0
      CASES(LEVEL)=NCASES
      OTHERS(LEVEL)=.FALSE.
      S0=S0+NCASES+2
20034 FND=.TRUE.
      GO TO 20024
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-FOR)
30007 ASSIGN 20041 TO NPR018
      GO TO 30018
20041 IF (.NOT.(FND)) GO TO 20042
      ASSIGN 20045 TO NPR014
      GO TO 30014
20045 ASSIGN 20046 TO NPR019
      GO TO 30019
20046 IF (FND) CALL SFTERR (1,
     X39H(Multiple use of structure index/label))
      ASSIGN 20047 TO NPR020
      GO TO 30020
20047 S1=S0+1
      S2=S0+2
      IF (.NOT.(.NOT.N2LIT)) GO TO 20048
      ASSIGN 20051 TO NPR021
      GO TO 30021
20051 CONTINUE
20048 IF (.NOT.(.NOT.N3LIT)) GO TO 20052
      ASSIGN 20055 TO NPR022
      GO TO 30022
20055 CONTINUE
20052 ASSIGN 20056 TO NPR023
      GO TO 30023
20056 ASSIGN 20057 TO NPR024
      GO TO 30024
20057 S1=S0+2
      S2=S0+3
      ASSIGN 20058 TO NPR025
      GO TO 30025
20058 IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      STRCTS(LEVEL)=DOFOR
      S1STAK(LEVEL)=S0+3
      EXITS(LEVEL)=.FALSE.
      CYCLES(LEVEL)=.FALSE.
      OTHERS(LEVEL)=.FALSE.
      ASSIGN 20059 TO NPR026
      GO TO 30026
20059 S0=S0+4
20042 FND=.TRUE.
      GO TO 20023
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-FOREVER)
C
C     TRANSLATE '[<LABEL>:] DO FOREVER' INTO 'S1 CONTINUE'.
C     SAVE '<LABEL>' IF ANY, AND S1.
30006 IF (.NOT.(.NOT. MORE)) GO TO 20060
      ASSIGN 20063 TO NPR014
      GO TO 30014
20063 ASSIGN 20064 TO NPR027
      GO TO 30027
20064 S1PNDG=S0+1
      IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      STRCTS(LEVEL)=FOREVR
      S1STAK(LEVEL)=S0+1
      EXITS(LEVEL)=.FALSE.
      CYCLES(LEVEL)=.FALSE.
      S0=S0+2
20060 FND=.TRUE.
      GO TO 20022
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-ONCE)
30009 IF (.NOT.(.NOT. MORE)) GO TO 20065
      ASSIGN 20068 TO NPR014
      GO TO 30014
20068 IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      S1=S0+1
      STRCTS(LEVEL)=ONCE
      S1STAK(LEVEL)=S1
      EXITS(LEVEL)=.FALSE.
      S0=S1
20065 FND=.TRUE.
      GO TO NPR009, (20025,20026)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-PROCEDURE)
30005 IF (.NOT.(.NOT.MORE)) GO TO 20069
      ASSIGN 20072 TO NPR014
      GO TO 30014
20072 S1=S0+1
      ASSIGN 20073 TO NPR028
      GO TO 30028
20073 S0=S0+1
20069 GO TO 20018
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-UNTIL)
30002 ASSIGN 20074 TO NPR013
      GO TO 30013
20074 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20075
      ASSIGN 20078 TO NPR014
      GO TO 30014
20078 S2=S0+2
      ASSIGN 20079 TO NPR023
      GO TO 30023
20079 S1=S0+1
      S2=S0+3
      ASSIGN 20080 TO NPR029
      GO TO 30029
20080 ASSIGN 20081 TO NPR027
      GO TO 30027
20081 S1PNDG=S0+2
      IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      STRCTS(LEVEL)=UNTIL
      S1STAK(LEVEL)=S0+1
      EXITS(LEVEL)=.FALSE.
      CYCLES(LEVEL)=.FALSE.
      S0=S0+3
20075 FND=.TRUE.
      GO TO 20015
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-WHILE)
30001 ASSIGN 20082 TO NPR013
      GO TO 30013
20082 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20083
      S1=S0+1
      ASSIGN 20086 TO NPR014
      GO TO 30014
20086 S2=S0+2
      ASSIGN 20087 TO NPR030
      GO TO 30030
20087 IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      STRCTS(LEVEL)=WHILE
      S1STAK(LEVEL)=S1
      EXITS(LEVEL)=.FALSE.
      CYCLES(LEVEL)=.FALSE.
      S0=S0+2
20083 FND=.TRUE.
      GO TO 20014
C
C-----------------------------------------------------------------------
C---- PROCEDURE (DO-WITH)
30003 IF (.NOT.(.NOT. MORE)) GO TO 20088
      ASSIGN 20091 TO NPR014
      GO TO 30014
20091 ASSIGN 20092 TO NPR027
      GO TO 30027
20092 S1PNDG=S0+1
      IF (LEVEL.GE.MAXLEV) CALL SFTERR (2,
     X28H(Too many levels of nesting))
      LEVEL=LEVEL+1
      STRCTS(LEVEL)=DOWITH
      S1STAK(LEVEL)=S0+2
      EXITS(LEVEL)=.FALSE.
      S0=S0+2
20088 FND=.TRUE.
      GO TO 20016
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO (S1, --- S2), INDEX')
30017 MAX=(NSMAX-LINDX-14)/7
      IF (S2-S1+1 .GT. MAX) CALL SFTERR (2,
     X37H(Too many numbers for computed GO-TO))
      CALL ADDBUF (13H      GO TO (,1,13)
      I=S1
      N20093=S2
      GO TO 20094
20093 I=I+1
20094 IF ((N20093-I).LT.0) GO TO 20095
      CALL ADDBUF (6H     ,,1,6)
      CALL NCODE (BUFFER,NB-5,NB-1,I)
      GO TO 20093
20095 NB=NB-1
      CALL ADDBUF (3H), ,1,3)
      CALL ADDBUF (NXXXS2,1,6)
      CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20040
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO S2')
30023 CALL GOTOS2
      GO TO NPR023, (20056,20079)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'IF (INDEX.LT.1.OR.INDEX.GT.NCASES) GO TO S2')
30016 CALL ADDBUF (10H      IF (,1,10)
      CALL ADDBUF(6HNX0000,1,6)
      CALL NCODE(BUFFER,NB-3,NB,S2)
      CALL ADDBUF (9H.LT.1.OR.,1,9)
      CALL ADDBUF(6HNX0000,1,6)
      CALL NCODE(BUFFER,NB-3,NB,S2)
      CALL ADDBUF (4H.GT.,1,4)
      CALL ADDBUF (STMT,CCNMBR,LNMBR)
      CALL ADDBUF (13H) GO TO      ,1,13)
      CALL NCODE (BUFFER,NB-4,NB,S2)
      ASSIGN 20097 TO NPR011
      GO TO 30011
20097 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20039
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'INDEX=N1')
30020 CALL ADDBUF (BLANKS,1,6)
      CALL ADDBUF (STMT,CCINDX,LINDX)
      CALL ADDBUF (1H=,1,1)
      CALL ADDBUF (STMT,CCN1,LN1)
      ASSIGN 20098 TO NPR011
      GO TO 30011
20098 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20047
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'N2XXS1=N2')
30021 CALL ADDBUF (13H      N20000=,1,13)
      CALL NCODE (BUFFER,9,12,S1)
      CALL ADDBUF (STMT,CCN2,LN2)
      CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20051
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'N3XXS1=N3')
30022 CALL ADDBUF (13H      N30000=,1,13)
      CALL NCODE (BUFFER,9,12,S1)
      CALL ADDBUF (STMT,CCN3,LN3)
      CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20055
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'NXXXS2=INDEX')
30015 CALL ADDBUF(13H      NX0000=,1,13)
      CALL NCODE(BUFFER,9,12,S2)
      CALL ADDBUF(STMT,CCINDX,LINDX)
      CALL F4MVC(BUFFER,7,NXXXS2,1,6)
      ASSIGN 20099 TO NPR011
      GO TO 30011
20099 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20038
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 IF (.NOT.(LOGIC)) GO TO S2')
30030 CALL GIFNLG
      GO TO 20087
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 IF (LOGIC) GO TO S2')
30029 CALL GIFLOG
      GO TO 20080
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 INDEX=INDEX+N3')
30024 CALL ADDBUF (BLANKS,1,6)
      CALL ADDBUF (STMT,CCINDX,LINDX)
      CALL ADDBUF (1H=,1,1)
      IF (.NOT.(LN3.EQ.0)) GO TO 20100
      CALL ADDBUF (STMT,CCINDX,LINDX)
      IF (.NOT.(N3VALU.GT.0)) GO TO 20103
      CALL ADDBUF (2H+1,1,2)
      GO TO 20104
20103 CALL ADDBUF (2H-1,1,2)
20104 GO TO 20101
20100 IF (.NOT.(N3LIT)) GO TO 20106
      CALL ADDBUF (STMT,CCN3,LN3)
      GO TO 20107
20106 CALL ADDBUF (6HN30000,1,6)
      CALL NCODE (BUFFER,NB-3,NB,S1)
20107 CALL ADDBUF (1H+,1,1)
      CALL ADDBUF (STMT,CCINDX,LINDX)
20101 ASSIGN 20109 TO NPR010
      GO TO 30010
20109 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20057
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S2 IF (N3*(N2-INDEX).LT.0) GO TO S3')
30025 CALL ADDBUF (10H      IF (,1,10)
      IF (.NOT.(N3LIT)) GO TO 20110
      IF (N3VALU.LT.0)  CALL ADDBUF (1H-,1,1)
      GO TO 20111
20110 CALL ADDBUF (7HN30000*,1,7)
      CALL NCODE (BUFFER,NB-4,NB-1,S1-1)
20111 CALL ADDBUF (1H(,1,1)
      IF (.NOT.(N2LIT)) GO TO 20113
      CALL ADDBUF (STMT,CCN2,LN2)
      GO TO 20114
20113 CALL ADDBUF (6HN20000,1,6)
      CALL NCODE (BUFFER,NB-3,NB,S1-1)
20114 CALL ADDBUF (1H-,1,1)
      CALL ADDBUF (STMT,CCINDX,LINDX)
      CALL ADDBUF (19H).LT.0) GO TO      ,1,19)
      CALL NCODE (BUFFER,NB-4,NB,S2)
      ASSIGN 20116 TO NPR010
      GO TO 30010
20116 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20058
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate Call to PROCEDURE)
30028 CALL GCALPR
      GO TO 20073
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Locate INDEX, N1, N2 and N3 Fields in DO-FOR)
30018 CCINDX=CCMORE
      FND=SCANER (LOCATE,1H=,1)
      IF (.NOT.(FND)) GO TO 20117
      LINDX=CC-CCINDX
      IF (.NOT.(LINDX.GT.MINDX)) GO TO 20120
      LINDX=MINDX
      CALL SFTERR (1,22H(Index name truncated))
20120 CCN1=CCMORE
      FND=SCANER (LOCATE,1H,,1)
      IF (.NOT.(FND)) GO TO 20123
      LN1=CC-CCN1
      CCN2=CCMORE
      COMNT=.FALSE.
      NSSAVE=NS
      IF (.NOT.(SCANER(LOCATE,COMCHR,1))) GO TO 20126
      COMNT=.TRUE.
      IF (.NOT.(LCCHR.GT.1)) GO TO 20129
      COMNT = F4CLC(STMT,CC,COMCHR,1,LCCHR)
20129 CONTINUE
20130 IF (.NOT.(COMNT)) GO TO 20132
      NS=CC-1
      MORE=.TRUE.
20132 CCMORE=CCN2
20126 CONTINUE
20127 IF (.NOT.(SCANER (LOCATE,1H,,1))) GO TO 20135
      LN2=CC-CCN2
      IF (.NOT.(MORE)) GO TO 20138
      CCN3=CCMORE
      GO TO 20142
20141 IF (.NOT.MORE .OR. .NOT.BLANK) GO TO 20143
20142 BLANK=SCANER (LOCATE,1H ,1)
      GO TO 20141
20143 IF (BLANK) NS=CC-1
      LN3=NS-CCN3+1
      GO TO 20139
20138 FND=.FALSE.
20139 GO TO 20136
20135 LN3=0
      GO TO 20145
20144 IF (.NOT.MORE .OR. .NOT.BLANK) GO TO 20146
20145 BLANK=SCANER (LOCATE,1H ,1)
      GO TO 20144
20146 IF (BLANK) NS=CC-1
      LN2=NS-CCN2+1
20136 IF (COMNT) NS=NSSAVE
      IF (.NOT.(FND)) GO TO 20147
      N2LIT=DCODE(STMT,CCN2,CCN2+LN2-1,N2VALU)
      IF (.NOT.(LN3.GT.0)) GO TO 20150
      N3LIT=DCODE(STMT,CCN3,CCN3+LN3-1,N3VALU)
      GO TO 20151
20150 N3LIT=.TRUE.
      N1LIT=DCODE(STMT,CCN1,CCN1+LN1-1,N1VALU)
      IF (.NOT.(N1LIT.AND.N2LIT)) GO TO 20153
      N3VALU=ISIGN(1,N2VALU-N1VALU)
      GO TO 20154
20153 N3VALU=1
20154 CONTINUE
20151 CONTINUE
20147 CONTINUE
20123 CONTINUE
20117 GO TO 20041
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output 'S1PNDG CONTINUE')
30027 CALL OPNCNT
      GO TO NPR027, (20064,20081,20092)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output SFTRAN Statement to List File)
30014 CALL OSFLST
      GO TO NPR014, (20037,20045,20063,20068,20072,20078,20086,20091)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Search Stack for Structure with this Index/Label)
30019 CALL SRSTAK
      GO TO 20046
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Stack Structure Index/Label)
30026 N=(LEVEL-1)*MINDX+1
      CALL F4MVC (BLANKS,1,INDEXS,N,MINDX)
      CALL F4MVC (STMT,CCINDX,INDEXS,N,LINDX)
      GO TO 20059
C
      END
