C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.8 [06-Dec-1991]
C-fpp- Date: Fri Jan 31 07:47:45 1992
C-fpp- Directory: /home/plot79/sf3dir
C-fpp- User:  <beebe@eros>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _MIPS=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      BLOCK DATA ZAPMEM
C     (Zap Memory)
C     In an effort to track down bugs in the SFTRAN3 preprocessor
C     due to use of  uninitialized values, this OPTIONAL  routine
C     is provided.  It  is NOT required  to build the  processor.
C     It initializes all  COMMON variables to  a number which  is
C     both  a  large  positive  integer,  as  well  as  a   large
C     floating-point number.  Use of such data is likely to cause
C     overflows  which  can  then  be  traced  to  the  offending
C     variable.  On machines which preinitialize memory to  zero,
C     tracking down such references can be very difficult,  since
C     only a divide is likely to reveal the problem.
C
C     This routine must be  loaded in such a  way as to  preserve
C     any other initializations defined  by the other BLOCK  DATA
C     routine, BLKDAT.  On  the DEC-10  and -20, and  on DEC  VAX
C     VMS, loading it BEFORE BLKDAT does the trick.  On Unix,  it
C     must be loaded AFTER BLKDAT.
C
C     A few  machines, notably  the CDC  6000/7000/Cyber  series,
C     have a command  to set  all of  uninitialized memory  (even
C     local subroutine variables) to  specific bit patterns,  and
C     on such machines, that will be a better solution than  this
C     routine provides.
C
C     What we really want are computer memories with an extra bit
C     set to mark the word  as undefined, with hardware  trapping
C     of read references  to it.  Regrettably,  only some of  the
C     Burroughs machines have this capability.
C     (25-JAN-86)
      INTEGER             OM01
      COMMON / COM01 /    OM01(16)
C
      INTEGER             OM02
      COMMON / COM02 /    OM02(1495)
C
      INTEGER             OM03
      COMMON / COM03 /    OM03(94)
C
      INTEGER             OM04
      COMMON / COM04 /    OM04(15)
C
      INTEGER             OM05
      COMMON / COM05 /    OM05(136)
C
      INTEGER             OM06
      COMMON / COM06 /    OM06(17)
C
      INTEGER             OM07
      COMMON / COM07 /    OM07(81)
C
      INTEGER             OM08
      COMMON / COM08 /    OM08(39)
C
      INTEGER             OM09
      COMMON / COM09 /    OM09(4)
C
      INTEGER             OM10
      COMMON / COM10 /    OM10(41)
C
      INTEGER             OM11
      COMMON / COM11 /    OM11(2)
C
      INTEGER             OM12
      COMMON / COM12 /    OM12(129)
C
      INTEGER             OM13
      COMMON / COM13 /    OM13(3)
C
      INTEGER             OM14
      COMMON / COM14 /    OM14(1)
C
      INTEGER             OM15
      COMMON / COM15 /    OM15(3)
C
      INTEGER             OM16
      COMMON / COM16 /    OM16(598)
C
      INTEGER             OM17
      COMMON / COM17 /    OM17(4)
C
      INTEGER             OM18
      COMMON / COM18 /    OM18(3)
C
      INTEGER             OM19
      COMMON / COM19 /    OM19(2)
C
      INTEGER             OM20
      COMMON / COM20 /    OM20(28)
C
      INTEGER             OM21
      COMMON / COM21 /    OM21(5)
C
      INTEGER             OM22
      COMMON / COM22 /    OM22(267)
C
      INTEGER             OM23
      COMMON / COM23 /    OM23(77)
C
      INTEGER             OM24
      COMMON / COM24 /    OM24(3)
C
      INTEGER             OM25
      COMMON / COM25 /    OM25(12)
C
      INTEGER             OM26
      COMMON / COM26 /    OM26(2)
C
      INTEGER             OM27
      COMMON / COM27 /    OM27(3001)
C
      INTEGER             OM28
      COMMON / COM28 /    OM28(1200)
C
      INTEGER             OM29
      COMMON / COM29 /    OM29(278)
C
      INTEGER             OM30
      COMMON / COM30 /    OM30(1327)
C
      INTEGER             OM31
      COMMON / COM31 /    OM31(1328)
C
      INTEGER             AV02
      COMMON / SAV02 /    AV02(40006)
C
C#if _OS_UNIX
C#if _AIX370
C##      DATA                OM01 / 16 * Z7fff7fff /
C##      DATA                OM02 / 1495 * Z7fff7fff /
C##      DATA                OM03 / 94 * Z7fff7fff /
C##      DATA                OM04 / 15 * Z7fff7fff /
C##      DATA                OM05 / 136 * Z7fff7fff /
C##      DATA                OM06 / 17 * Z7fff7fff /
C##      DATA                OM07 / 81 * Z7fff7fff /
C##      DATA                OM08 / 39 * Z7fff7fff /
C##      DATA                OM09 / 4 * Z7fff7fff /
C##      DATA                OM10 / 41 * Z7fff7fff /
C##      DATA                OM11 / 2 * Z7fff7fff /
C##      DATA                OM12 / 129 * Z7fff7fff /
C##      DATA                OM13 / 3 * Z7fff7fff /
C##      DATA                OM14 / 1 * Z7fff7fff /
C##      DATA                OM15 / 3 * Z7fff7fff /
C##      DATA                OM16 / 598 * Z7fff7fff /
C##      DATA                OM17 / 4 * Z7fff7fff /
C##      DATA                OM18 / 3 * Z7fff7fff /
C##      DATA                OM19 / 2 * Z7fff7fff /
C##      DATA                OM20 / 28 * Z7fff7fff /
C##      DATA                OM21 / 5 * Z7fff7fff /
C##      DATA                OM22 / 267 * Z7fff7fff /
C##      DATA                OM23 / 77 * Z7fff7fff /
C##      DATA                OM24 / 3 * Z7fff7fff /
C##      DATA                OM25 / 12 * Z7fff7fff /
C##      DATA                OM26 / 2 * Z7fff7fff /
C##      DATA                OM27 / 3001 * Z7fff7fff /
C##      DATA                OM28 / 1200 * Z7fff7fff /
C##      DATA                OM29 / 278 * Z7fff7fff /
C##      DATA                OM30 / 1327 * Z7fff7fff /
C##      DATA                OM31 / 1328 * Z7fff7fff /
C##      DATA                AV02 / 40006 * Z7fff7fff /
C#else
      DATA                OM01 / 16 * Z'7fff7fff' /
      DATA                OM02 / 1495 * Z'7fff7fff' /
      DATA                OM03 / 94 * Z'7fff7fff' /
      DATA                OM04 / 15 * Z'7fff7fff' /
      DATA                OM05 / 136 * Z'7fff7fff' /
      DATA                OM06 / 17 * Z'7fff7fff' /
      DATA                OM07 / 81 * Z'7fff7fff' /
      DATA                OM08 / 39 * Z'7fff7fff' /
      DATA                OM09 / 4 * Z'7fff7fff' /
      DATA                OM10 / 41 * Z'7fff7fff' /
      DATA                OM11 / 2 * Z'7fff7fff' /
      DATA                OM12 / 129 * Z'7fff7fff' /
      DATA                OM13 / 3 * Z'7fff7fff' /
      DATA                OM14 / 1 * Z'7fff7fff' /
      DATA                OM15 / 3 * Z'7fff7fff' /
      DATA                OM16 / 598 * Z'7fff7fff' /
      DATA                OM17 / 4 * Z'7fff7fff' /
      DATA                OM18 / 3 * Z'7fff7fff' /
      DATA                OM19 / 2 * Z'7fff7fff' /
      DATA                OM20 / 28 * Z'7fff7fff' /
      DATA                OM21 / 5 * Z'7fff7fff' /
      DATA                OM22 / 267 * Z'7fff7fff' /
      DATA                OM23 / 77 * Z'7fff7fff' /
      DATA                OM24 / 3 * Z'7fff7fff' /
      DATA                OM25 / 12 * Z'7fff7fff' /
      DATA                OM26 / 2 * Z'7fff7fff' /
      DATA                OM27 / 3001 * Z'7fff7fff' /
      DATA                OM28 / 1200 * Z'7fff7fff' /
      DATA                OM29 / 278 * Z'7fff7fff' /
      DATA                OM30 / 1327 * Z'7fff7fff' /
      DATA                OM31 / 1328 * Z'7fff7fff' /
      DATA                AV02 / 40006 * Z'7fff7fff' /
C#endif
C#elif _OS_TOPS20
C##      DATA                OM01 / 16 * "377777777777 /
C##      DATA                OM02 / 1495 * "377777777777 /
C##      DATA                OM03 / 94 * "377777777777 /
C##      DATA                OM04 / 15 * "377777777777 /
C##      DATA                OM05 / 136 * "377777777777 /
C##      DATA                OM06 / 17 * "377777777777 /
C##      DATA                OM07 / 81 * "377777777777 /
C##      DATA                OM08 / 39 * "377777777777 /
C##      DATA                OM09 / 4 * "377777777777 /
C##      DATA                OM10 / 41 * "377777777777 /
C##      DATA                OM11 / 2 * "377777777777 /
C##      DATA                OM12 / 129 * "377777777777 /
C##      DATA                OM13 / 3 * "377777777777 /
C##      DATA                OM14 / 1 * "377777777777 /
C##      DATA                OM15 / 3 * "377777777777 /
C##      DATA                OM16 / 598 * "377777777777 /
C##      DATA                OM17 / 4 * "377777777777 /
C##      DATA                OM18 / 3 * "377777777777 /
C##      DATA                OM19 / 2 * "377777777777 /
C##      DATA                OM20 / 28 * "377777777777 /
C##      DATA                OM21 / 5 * "377777777777 /
C##      DATA                OM22 / 267 * "377777777777 /
C##      DATA                OM23 / 77 * "377777777777 /
C##      DATA                OM24 / 3 * "377777777777 /
C##      DATA                OM25 / 12 * "377777777777 /
C##      DATA                OM26 / 2 * "377777777777 /
C##      DATA                OM27 / 3001 * "377777777777 /
C##      DATA                OM28 / 1200 * "377777777777 /
C##      DATA                OM29 / 278 * "377777777777 /
C##      DATA                OM30 / 1327 * "377777777777 /
C##      DATA                OM31 / 1328 * "377777777777 /
C##      DATA                AV02 / 40006 * "377777777777 /
C#endif
C
      END
