C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.8 [06-Dec-1991]
C-fpp- Date: Fri Jan 31 07:47:44 1992
C-fpp- Directory: /home/plot79/sf3dir
C-fpp- User:  <beebe@eros>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _MIPS=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      SUBROUTINE  SFTRN1
C                ---  SFTRAN Precompiler, Main Program  ---
C
C **********************************************************************
C *                                                                    *
C *                       -- Acknowledgment --                         *
C *                                                                    *
C *    This program is derived from the work of John A. Flynn as       *
C *    reported in his 'SFTRAN User Guide', J. P. L. Interoffice       *
C *    Computing Memorandum No 337 (Section 914), July 31, 1973 and    *
C *    its supplements, and also from Flynn's SFTRAN code itself.      *
C *                                                                    *
C **********************************************************************
C
C      Program-control parameters:
C
C       ERRORS = error indicator (.TRUE. if any are detected).
C       MAXIN = Maximum logical record length of input (and
C               FORTRAN output).  Long statements are continued
C               as necessary to stay within this maximum length.
C       SPACES = no. of indentation spaces per structure level.
C       INLINE( ) = directive to define character(s) that initiate
C                   commentary text on an SFTRAN statement.
C       STET( ) = directive to define STET character
C       LINEUP[( )] = directive to connect control structures at same
C                indentation level.
C       NOLINEUP = directive to disable LINEUP directive.
C       INDENT[( )] = directive to re-enable indentation and/or
C                       to specify indentation tab size.
C       NOINDENT = directive to disable indentation.
C       INCLUDE = directive to incorporate named source text in
C                 input runstream.
C       LBASE = base value used for statement numbers generated by
C               ELSEIF statements.
C       SBASE = base value used for statement numbers generated by
C               SFTRAN (all except PROCEDURE entry points and
C               ELSEIF statements).
C       PBASE = base value used for statement numbers attached to
C               PROCEDURE entry points.
C       HOLDIO = unit number for holding definition blocks.
C       INSF = unit number for SFTRAN input.
C       OUTSF = unit number for SFTRAN output.
C       TEMPF4 = unit number for temporary FORTRAN.
C       OUTF4 = unit number for final FORTRAN output.
C       OUTERR = unit number for error messages.
C
C     (12-MAY-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       ADDBUF,      ALFTOK,      BLDHT1,      BLDHT2
C     EXTERNAL REFS       CNAMNX,      DCODE,       DEMAND,      F4CLC
C     EXTERNAL REFS       F4MVC,       GNAMNO,      INITRZ,      IOFUNC
C     EXTERNAL REFS       MIN0,        NCODE,       OPNCNT,      OSFRFL
C     EXTERNAL REFS       PARENS,      P79OPT,      SAVLBL,      SCANER
C     EXTERNAL REFS       SFTERR,      SFTRN2,      SFTRN3,      SFTRN4
C     EXTERNAL REFS       SQUEEZ,      SRCHHT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             P79OPT
      LOGICAL             DCODE,       DEMAND,      F4CLC,       PARENS
      LOGICAL             SCANER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MIN0
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     HOLLERITH STRING VARIABLES
C
      INTEGER             DFCOM,       DFLNUP,      DFSTET
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CC1,         CC7,         CCSAVE,      CYCLE
C     SETS                DFCOML,      EXIT,        I,           INDX
C     SETS                LASTLV,      LENGTH,      LINE1,       LINE2
C     SETS                LJUNK,       NEXTCH,      RETURN,      STOP
C
      INTEGER             CC1,         CC7,         CCNEXT,      CCSAVE
      INTEGER             CYCLE,       DFCOML,      DUMMY
      INTEGER             EXIT,        I,           INDX,        JUNK
      INTEGER             L,           LASTLV,      LENGTH,      LINE1
      INTEGER             LINE2,       NEXTCH,      RETURN,      STOP
      INTEGER             TEMP(2),     TRMNAL,      TYPE
      LOGICAL             LJUNK
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM06  /
C
      INTEGER             F4KEY,       HOLDIO,      INSF,        LINE
      INTEGER             LINENO,      MAXIN,       MDATA,       OUTERR
      INTEGER             OUTF4,       OUTSF,       P2BASE,      PBASE
      INTEGER             SBASE,       SFKEY,       SPACES,      TEMPF4
      LOGICAL             ERRORS
      COMMON / COM06  /   ERRORS,      F4KEY,       HOLDIO,      INSF
      COMMON / COM06  /   LINE,        LINENO,      MAXIN,       MDATA
      COMMON / COM06  /   OUTERR,      OUTF4,       OUTSF,       P2BASE
      COMMON / COM06  /   PBASE,       SBASE,       SFKEY,       SPACES
      COMMON / COM06  /   TEMPF4
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM10  /
C
      INTEGER             L0,          L1STAK,      LBASE
C
      COMMON / COM10  /   L0,          L1STAK(39),  LBASE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM11  /
C
      INTEGER             COMCHR,      LCCHR
C
      COMMON / COM11  /   COMCHR(1),   LCCHR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM12  /
C
      INTEGER             ALIGN,       LNUPCH,      MAXOUT,      STETCH
      LOGICAL             COMMNT,      DRECTV,      EXEMPT,      LINEUP
      LOGICAL             NONDNT,      STET
C
      COMMON / COM12  /   ALIGN(120),  COMMNT,      DRECTV,      EXEMPT
      COMMON / COM12  /   LINEUP,      LNUPCH(1),   MAXOUT,      NONDNT
      COMMON / COM12  /   STET,        STETCH(1)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM13  /
C
      INTEGER             ADDERR
      LOGICAL             ADELT,       SFLIST
C
      COMMON / COM13  /   ADDERR,      ADELT,       SFLIST
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM15  /
C
      INTEGER             ININCL,      INSFSV,      MCOUNT
      COMMON / COM15  /   ININCL,      INSFSV,      MCOUNT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM16  /
C
      INTEGER             LINES
C
      COMMON / COM16  /   LINES(2,299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM18  /
C
      LOGICAL             DEBUG,       NOSFL,       PRETTY
C
      COMMON / COM18  /   DEBUG,       NOSFL,       PRETTY
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM22  /
C
      INTEGER             HASHT1,      MAXHT1,      PRIME1
C
      COMMON / COM22  /   HASHT1(265), MAXHT1,      PRIME1
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM23  /
C
      INTEGER             HASHT2,      MAXHT2,      PRIME2
C
      COMMON / COM23  /   HASHT2(75),  MAXHT2,      PRIME2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM24  /
C
      INTEGER             FIND,        LOCATE,      SCAN
C
      COMMON / COM24  /   FIND,        LOCATE,      SCAN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM27  /
C
      INTEGER             LNAME,       LNAMES,      MAXTAB,      MNAMES
      INTEGER             NAMENO,      NAMTAB,      NNAMES,      USES
      INTEGER             DEFS
C
      COMMON / COM27  /   LNAME,       LNAMES(299), MAXTAB,      MNAMES
      COMMON / COM27  /   NAMENO,      NAMTAB(2099),NNAMES
      COMMON / COM27  /   USES(299),   DEFS(299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM28  /
C
      INTEGER             MCALLS,      NCALLS,      NAMNOS,      SCALLS
C
      COMMON / COM28  /   MCALLS,      NCALLS,      NAMNOS(599)
      COMMON / COM28  /   SCALLS(599)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM30  /
C
      INTEGER             NB,          BUFFER
C
      COMMON / COM30  /   NB,          BUFFER(1326)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
      DATA                CC1       / 1 /
      DATA                CC7       / 7 /
      DATA                CYCLE     / 18 /
      DATA                EXIT      / 9 /
      DATA                RETURN    / 17 /
      DATA                STOP      / 16 /
C
C     The following symbolic constants DFCOM, DFCOML, DFSTET, and
C     DFLNUP  are  established  for  initializing  the  following
C     variables in the  code for PROCEDURE  (Initialize For  Pass
C     1):
C
C     COMCHR(*) -- default inline comment character
C     STETCH(*) -- default character suppressing comment indentation
C                  (dollar sign)
C     LNUPCH(*) -- default character used for lineup lines connecting
C                  structure start--end points.  (Colon, but a
C                  vertical bar could also be used)
C
      DATA                DFCOM     / 1H@ /
      DATA                DFCOML    / 1 /
      DATA                DFLNUP    / 1H: /
      DATA                DFSTET    / 1H$ /
C
C     MAIN PROGRAM FLOW:
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 ASSIGN 20002 TO NPR002
      GO TO 30002
20002 IF (.NOT.(.NOT.ERRORS)) GO TO 20003
      ASSIGN 20006 TO NPR003
      GO TO 30003
20006 GO TO 20004
C#if _OS_UNIX
20003 IF (DEMAND(TRMNAL)) WRITE(0,1)
C#elif _OS_VAXVMS
C##           IF (DEMAND(TRMNAL)) WRITE(*,1)
C#else
C##           IF (DEMAND(TRMNAL)) WRITE(6,1)
C#endif
      IF (OUTSF .GT. 0) WRITE (OUTSF,1)
20004 CONTINUE
C
20005 RETURN
C
C     Pass 1 and Pass 2 procedures:
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check For '(Name)' Next)
30004 CALL CNAMNX
      GO TO 20146
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check of PROCEDURE/Definition Name Usage)
30002 IF (.NOT.(NNAMES.GT.0)) GO TO 20007
      NEXTCH=1
      I=1
      N20010=NNAMES
      GO TO 20011
20010 I=I+1
20011 IF ((N20010-I).LT.0) GO TO 20012
      LNAME=LNAMES(I)
      IF (.NOT.((USES(I).EQ.0) .OR. (DEFS(I).EQ.0))) GO TO 20014
      CALL F4MVC (17H      BAD NAME = ,1,STMT,1,17)
      CALL F4MVC (NAMTAB,NEXTCH,STMT,18,LNAME)
      NS=17+LNAME
      IF (USES(I).EQ.0) CALL SFTERR (1,
     X17H(Name never used))
      IF (DEFS(I).EQ.0) CALL SFTERR (1,
     X18H(Name not defined))
20014 CONTINUE
20015 NEXTCH=NEXTCH+LNAME
      GO TO 20010
20012 CONTINUE
20007 CONTINUE
20008 GO TO 20002
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'END INCLUDE')
30005 DRECTV=.TRUE.
      ADELT=.FALSE.
      GO TO 20062
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'INCLUDE')
30006 DRECTV=.TRUE.
      IF (ADDERR.EQ.0) ADELT=.TRUE.
      GO TO 20063
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'INDENT')
30007 DRECTV=.TRUE.
      NONDNT=.FALSE.
      IF (.NOT.(PARENS(STMT,CCMORE,NS,LEFT,RIGHT))) GO TO 20017
      RIGHT = MIN0(LEFT+3,RIGHT)
      CALL SQUEEZ(LEFT+1,RIGHT-1,TEMP,L)
      LJUNK=DCODE(TEMP,1,L,SPACES)
      IF (.NOT.(SPACES.GT.0)) GO TO 20020
      CALL F4MVC(BLANKS,1,ALIGN,1,MAXOUT/2)
      INDX=1
      N20023=MAXOUT/2
      N30023=SPACES
      GO TO 20024
20023 INDX=N30023+INDX
20024 IF (N30023*(N20023-INDX).LT.0) GO TO 20025
      CALL F4MVC(LNUPCH,1,ALIGN,INDX,1)
      GO TO 20023
20025 CONTINUE
20020 CONTINUE
20017 GO TO 20064
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'INLINE')
30008 DRECTV=.TRUE.
      IF (.NOT.(PARENS(STMT,CCMORE,NS,LEFT,RIGHT))) GO TO 20027
      CALL SQUEEZ(LEFT+1,RIGHT-1,COMCHR,LCCHR)
      GO TO 20028
20027 CALL SFTERR(1,36H(INLINE comment character not named))
20028 GO TO 20065
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'LINEUP')
30009 DRECTV=.TRUE.
      LINEUP=.TRUE.
      IF (.NOT.(PARENS(STMT,CCMORE,NS,LEFT,RIGHT))) GO TO 20030
      CALL SQUEEZ(LEFT+1,RIGHT-1,LNUPCH,L)
20030 CALL F4MVC(BLANKS,1,ALIGN,1,MAXOUT/2)
      IF (.NOT.(SPACES.GT.0)) GO TO 20033
      INDX=1
      N20036=MAXOUT/2
      N30036=SPACES
      GO TO 20037
20036 INDX=N30036+INDX
20037 IF (N30036*(N20036-INDX).LT.0) GO TO 20038
      CALL F4MVC(LNUPCH,1,ALIGN,INDX,1)
      GO TO 20036
20038 CONTINUE
20033 GO TO 20066
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'NOINDENT')
30010 DRECTV=.TRUE.
      NONDNT=.TRUE.
      GO TO 20067
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'NOLINEUP')
30011 DRECTV=.TRUE.
      LINEUP=.FALSE.
      GO TO 20068
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Directive = 'STET')
30012 DRECTV=.TRUE.
      IF (.NOT.(PARENS(STMT,CCMORE,NS,LEFT,RIGHT))) GO TO 20040
      CALL SQUEEZ(LEFT+1,RIGHT-1,STETCH,L)
      GO TO 20041
20040 CALL SFTERR(1,26H(STET character not named))
20041 IF (L.LT.1) CALL SFTERR(1,
     X34H(Blank STET character not allowed))
      GO TO 20069
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Examine Statement For SFTRAN Directives)
30013 LJUNK = SCANER(SCAN,DUMMY,CC1)
      DRECTV=.FALSE.
      IF (.NOT.(MORE .AND. (CCMORE.EQ.1))) GO TO 20043
      CALL ALFTOK (STMT,NS,CCMORE,CCNEXT)
      LENGTH = CCNEXT - CCMORE
      IF (.NOT.(LENGTH .GT. 0)) GO TO 20046
      CALL SRCHHT (STMT,CCMORE,LENGTH,HASHT2,JUNK,TYPE)
      NX0057=TYPE
      IF (NX0057.LT.1.OR.NX0057.GT.8) GO TO 20057
      GO TO (20049,20050,20051,20052,20053,20054,20055,20056), NX0057
20049 IF (.NOT.(SCANER(FIND,11HEND INCLUDE,11))) GO TO 20059
      ASSIGN 20062 TO NPR005
      GO TO 30005
20062 CONTINUE
20059 CONTINUE
20060 GO TO 20058
20050 LJUNK = SCANER(FIND,7HINCLUDE,7)
      ASSIGN 20063 TO NPR006
      GO TO 30006
20063 GO TO 20058
20051 LJUNK = SCANER(FIND,6HINDENT,6)
      ASSIGN 20064 TO NPR007
      GO TO 30007
20064 GO TO 20058
20052 LJUNK = SCANER(FIND,6HINLINE,6)
      ASSIGN 20065 TO NPR008
      GO TO 30008
20065 GO TO 20058
20053 LJUNK = SCANER(FIND,6HLINEUP,6)
      ASSIGN 20066 TO NPR009
      GO TO 30009
20066 GO TO 20058
20054 LJUNK = SCANER(FIND,8HNOINDENT,8)
      ASSIGN 20067 TO NPR010
      GO TO 30010
20067 GO TO 20058
20055 LJUNK = SCANER(FIND,8HNOLINEUP,8)
      ASSIGN 20068 TO NPR011
      GO TO 30011
20068 GO TO 20058
20056 LJUNK = SCANER(FIND,4HSTET,4)
      ASSIGN 20069 TO NPR012
      GO TO 30012
20069 CONTINUE
20057 CONTINUE
20058 CONTINUE
20046 CONTINUE
20043 GO TO 20169
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate Assigned GOTO with Statement Numbers)
30014 FND=DCODE(STMT,16,NS,NAMENO)
      IF (.NOT.(FND .AND. (NAMENO.NE.0))) GO TO 20070
      CALL ADDBUF (STMT,1,NS)
      CALL ADDBUF (3H, (,1,3)
      FND = .FALSE.
      I=1
      N20073=NCALLS
      GO TO 20074
20073 I=I+1
20074 IF ((N20073-I).LT.0) GO TO 20075
      IF (.NOT.(NAMENO.EQ.NAMNOS(I))) GO TO 20077
      IF (NB+6 .GT. NSMAX) CALL SFTERR (2,
     X36H(Too many numbers for assigned GOTO))
      CALL ADDBUF (6H     ,,1,6)
      CALL NCODE (BUFFER,NB-5,NB-1,SCALLS(I))
      FND = .TRUE.
20077 GO TO 20073
20075 IF (.NOT.(FND)) GO TO 20080
      IF (.NOT.(NB .NE. 27)) GO TO 20083
      NB=NB-1
      CALL ADDBUF (1H),1,1)
      GO TO 20084
20083 CALL F4MVC (BUFFER,22,BUFFER,13,5)
      NB = 17
20084 GO TO 20081
20080 CALL F4MVC (8HCONTINUE,1,BUFFER,7,8)
      NB = 14
20081 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20071
20070 ASSIGN 20086 TO NPR015
      GO TO 30015
20086 CONTINUE
20071 GO TO 20186
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Get PROCEDURE/Definition Name Number)
30016 CALL GNAMNO
      GO TO 20150
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize For Pass 1)
30017 ADDERR = 0
      MCOUNT = 0
      IF (ININCL .GT. 0) REWIND ININCL
      COMCHR(1) = DFCOM
      LCCHR = DFCOML
      NSTACK = 0
      STETCH(1) = DFSTET
      LNUPCH(1) = DFLNUP
      CALL F4MVC (1H ,1,BLANKS,1,1)
      CALL F4MVC (BLANKS,1,BLANKS,2,91)
      CALL BLDHT1
      CALL BLDHT2
      ERRORS=.FALSE.
      LABEL = .FALSE.
      NOFLOW=.FALSE.
      NONDNT=.FALSE.
      STET  =.FALSE.
      LINEUP = (P79OPT(1HL) .EQ. 0)
      INDX = P79OPT(1HI)
      IF (INDX .GT. 0) SPACES = INDX
      IF (.NOT.(LINEUP .AND. (SPACES .GT. 0))) GO TO 20087
      CALL F4MVC (BLANKS,1,ALIGN,1,MAXOUT/2)
      INDX =1
      N20090=MAXOUT/2
      N30090=SPACES
      GO TO 20091
20090 INDX =N30090+INDX
20091 IF (N30090*(N20090-INDX ).LT.0) GO TO 20092
      CALL F4MVC (LNUPCH,1,ALIGN,INDX,1)
      GO TO 20090
20092 CONTINUE
20087 SFLIST = .TRUE.
      DEBUG = (P79OPT(1HD) .GE. 0)
      NOSFL = (P79OPT(1HN) .GE. 0)
      PRETTY = (P79OPT(1HP) .GE. 0)
      ADELT=.FALSE.
      INDENT = 0
      LEVEL=0
      UNDENT=0
      NNAMES=0
      S1PNDG=0
      NCALLS=0
      S0=SBASE
      L0=LBASE
      NB=0
      NHELD=0
      FIRST=.TRUE.
      LAST=.FALSE.
      IN=INSF
      OUT=TEMPF4
      GO TO 20157
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize For Pass 2)
30018 FIRST=.TRUE.
      IN=TEMPF4
      OUT=OUTF4
      GO TO 20176
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize RJZF Character Constants)
30019 CALL INITRZ
      GO TO 20156
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Look For SFTRAN Statements and Translate Them)
30020 FOUND=.FALSE.
      XLATED=.FALSE.
      INDENT=LEVEL
      ASSIGN 20094 TO NPR021
      GO TO 30021
20094 CALL ALFTOK (STMT,NS,CCMORE,CCNEXT)
      LENGTH = CCNEXT - CCMORE
      IF (.NOT.(LENGTH .GT. 0)) GO TO 20095
      CALL SRCHHT (STMT,CCMORE,LENGTH,HASHT1,JUNK,TYPE)
      NX0116=TYPE
      IF (NX0116.LT.1.OR.NX0116.GT.18) GO TO 20116
      GO TO (20098,20099,20100,20101,20102,20103,20104,20105,20106,20107
     X,20108,20109,20110,20111,20112,20113,20114,20115), NX0116
20098 LJUNK = SCANER (FIND,3HEND,3)
      LASTLV = LEVEL
      CALL SFTRN2(1)
      IF (.NOT.(DEBUG .AND. (LASTLV .GT. 0))) GO TO 20118
      ASSIGN 20118 TO NPR022
      GO TO 30022
20118 GO TO 20117
20099 LJUNK = SCANER (FIND,2HIF,2)
      CALL SFTRN2(2)
      IF (.NOT.(DEBUG)) GO TO 20119
      ASSIGN 20119 TO NPR022
      GO TO 30022
20119 GO TO 20117
20100 LJUNK = SCANER (FIND,2HDO,2)
      CALL SFTRN3
      IF (.NOT.(DEBUG)) GO TO 20120
      ASSIGN 20120 TO NPR022
      GO TO 30022
20120 GO TO 20117
20101 LJUNK = SCANER (FIND,4HELSE,4)
      IF (.NOT.(MORE)) GO TO 20121
      IF (SCANER (FIND,2HIF,2)) CALL SFTRN4(15)
      GO TO 20122
20121 CALL SFTRN4(1)
20122 IF (.NOT.(DEBUG)) GO TO 20124
      ASSIGN 20124 TO NPR022
      GO TO 30022
20124 GO TO 20117
20102 LJUNK = SCANER (FIND,9HPROCEDURE,9)
      ASSIGN 20125 TO NPR023
      GO TO 30023
20125 CALL SFTRN4(2)
      ASSIGN 20126 TO NPR022
      GO TO 30022
20126 GO TO 20117
20103 LJUNK = SCANER (FIND,4HCASE,4)
      CALL SFTRN4(3)
      IF (.NOT.(DEBUG)) GO TO 20127
      ASSIGN 20127 TO NPR022
      GO TO 30022
20127 GO TO 20117
20104 LJUNK = SCANER (FIND,5HWHILE,5)
      CALL SFTRN4(4)
      IF (.NOT.(DEBUG)) GO TO 20128
      ASSIGN 20128 TO NPR022
      GO TO 30022
20128 GO TO 20117
20105 LJUNK = SCANER (FIND,5HUNTIL,5)
      CALL SFTRN4(5)
      IF (.NOT.(DEBUG)) GO TO 20129
      ASSIGN 20129 TO NPR022
      GO TO 30022
20129 GO TO 20117
20106 LJUNK = SCANER (FIND,4HEXIT,4)
      CALL SFTRN4(6)
      IF (.NOT.(DEBUG)) GO TO 20130
      ASSIGN 20130 TO NPR022
      GO TO 30022
20130 GO TO 20117
20107 LJUNK = SCANER (FIND,9HOTHERWISE,9)
      CALL SFTRN4 (7)
      GO TO 20117
20108 LJUNK = SCANER (FIND,4HREAD,4)
      CALL SFTRN4(8)
      GO TO 20117
20109 LJUNK = SCANER (FIND,5HWRITE,5)
      CALL SFTRN4 (8)
      GO TO 20117
20110 LJUNK = SCANER (FIND,5HENTRY,5)
      CALL SFTRN4(9)
      GO TO 20117
20111 LJUNK = SCANER (FIND,7HINCLUDE,7)
      CALL SFTRN4(10)
      GO TO 20117
20112 LJUNK = SCANER (FIND,10HDEFINITION,10)
      CALL SFTRN4(11)
      GO TO 20117
20113 LJUNK = SCANER (FIND,4HSTOP,4)
      CALL SFTRN4(12)
      GO TO 20117
20114 LJUNK = SCANER (FIND,6HRETURN,6)
      CALL SFTRN4(13)
      GO TO 20117
20115 LJUNK = SCANER (FIND,5HCYCLE,5)
      CALL SFTRN4(14)
      IF (.NOT.(DEBUG)) GO TO 20131
      ASSIGN 20131 TO NPR022
      GO TO 30022
20131 CONTINUE
20116 CONTINUE
20117 CONTINUE
20095 NOFLOW=XLATED .AND. ((TYPE.EQ.EXIT) .OR. (TYPE.EQ.STOP )
     X.OR. (TYPE.EQ.RETURN) .OR. (TYPE.EQ.CYCLE))
      GO TO 20206
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output 'INCLUDE' Diagnostic)
30024 NX0136=ADDERR
      IF (NX0136.LT.1.OR.NX0136.GT.4) GO TO 20136
      GO TO (20132,20133,20134,20135), NX0136
20132 CALL SFTERR(1,23H(INCLUDE name is empty))
      GO TO 20137
20133 CALL SFTERR(1,25H(INCLUDE file is unknown))
      GO TO 20137
20134 CALL SFTERR(1,28H(INCLUDE element is unknown))
      GO TO 20137
20135 CALL SFTERR(1,31H(INCLUDE stmt has format error))
      GO TO 20137
20136 CALL SFTERR(1,38H(INCLUDE error of undetermined origin))
20137 ADDERR=0
      GO TO 20201
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output 'S1PNDG CONTINUE')
30025 CALL OPNCNT
      GO TO 20175
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Exempt Statement to List and FORTRAN Files)
30026 INDENT=0
      IF (STET .AND. .NOT.PRETTY) CALL F4MVC(BLANKS,1,STMT,2,1)
      ASSIGN 20138 TO NPR027
      GO TO 30027
20138 CALL IOFUNC (F4OUT,STMT,NS)
      GO TO 20205
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Separator Line For Visibility)
30023 EXEMPT = .TRUE.
      COMMNT = .TRUE.
      CCSAVE = CCMORE
      CALL F4MVC (2HC-,1,BUFFER,1,2)
      I =3
      GO TO 20140
20139 I =10+I
20140 IF ((63-I ).LT.0) GO TO 20141
      CALL F4MVC (10H----------,1,BUFFER,I,10)
      GO TO 20139
20141 CALL IOFUNC (F4OUT,BUFFER,MAXIN)
      IF (.NOT.(.NOT.PRETTY .AND. .NOT.NOSFL)) GO TO 20143
      CALL IOFUNC (SFOUT,BUFFER,MAXIN)
      CALL F4MVC (6HC      ,1,BUFFER,1,6)
      CALL IOFUNC (SFOUT,BUFFER,6)
20143 CCMORE = CCSAVE
      EXEMPT = .FALSE.
      COMMNT = .FALSE.
      GO TO 20125
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output SFTRAN Statement as a FORTRAN Comment)
30022 EXEMPT = .TRUE.
      COMMNT = .TRUE.
      CALL F4MVC (STMT,1,BUFFER,1,NS)
      CALL F4MVC (5HC----,1,BUFFER,1,5)
      CALL IOFUNC (F4OUT,BUFFER,MIN0(MAXIN,NS))
      EXEMPT = .FALSE.
      COMMNT = .FALSE.
      GO TO NPR022, (20118,20119,20120,20124,20126,20127,20128,20129,201
     X30,20131)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Statement to FORTRAN File)
30015 CALL OSFRFL
      GO TO NPR015, (20086,20187,20211)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Statement to List File)
30027 IF (SFLIST .AND. .NOT.NOSFL) CALL IOFUNC(SFOUT,STMT,NS)
      GO TO NPR027, (20138,20191,20210,20212)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output the Definition Block in Place of INCLUDE)
30028 CCSAVE=CC
      ASSIGN 20146 TO NPR004
      GO TO 30004
20146 IF (.NOT.(FND .AND. .NOT.MORE .AND. CCSAVE.EQ.7)) GO TO 20147
      ASSIGN 20150 TO NPR016
      GO TO 30016
20150 LINE1=LINES(1,NAMENO)
      LINE2=LINES(2,NAMENO)
      IN=HOLDIO
      IF (.NOT.(NHELD.GE.LINE1)) GO TO 20151
      REWIND HOLDIO
      NHELD=0
20151 CONTINUE
20154 IF (.NOT.(NHELD.LT.LINE2)) GO TO 20155
      CALL IOFUNC (INPUT,STMT,NS)
      NHELD=NHELD+1
      IF (NHELD.GE.LINE1)  CALL IOFUNC (F4OUT,STMT,NS)
      GO TO 20154
20155 IN=TEMPF4
      GO TO 20148
20147 CALL IOFUNC (F4OUT,STMT,NS)
20148 GO TO 20182
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Pass 1: Find SFTRAN Statements and Translate Them)
30001 ASSIGN 20156 TO NPR019
      GO TO 30019
20156 ASSIGN 20157 TO NPR017
      GO TO 30017
20157 GO TO 20159
20158 IF (LAST .OR. EOF) GO TO 20160
20159 CALL IOFUNC (INPUT,STMT,NS)
      IF (.NOT.(.NOT.EOF)) GO TO 20161
      ASSIGN 20164 TO NPR029
      GO TO 30029
20164 IF (.NOT.(EXEMPT .OR. COMMNT)) GO TO 20165
      ASSIGN 20168 TO NPR030
      GO TO 30030
20168 GO TO 20166
20165 ASSIGN 20169 TO NPR013
      GO TO 30013
20169 IF (.NOT.(DRECTV)) GO TO 20170
      ASSIGN 20173 TO NPR031
      GO TO 30031
20173 GO TO 20171
20170 ASSIGN 20174 TO NPR030
      GO TO 30030
20174 CONTINUE
20171 CONTINUE
20166 CONTINUE
20161 GO TO 20158
20160 ASSIGN 20175 TO NPR025
      GO TO 30025
20175 IF (LEVEL.GT.0) CALL SFTERR (1,22H(Final END(s) missing))
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Pass 2: Complete Assigned GO-TOs and INCLUDEs)
30003 ASSIGN 20176 TO NPR018
      GO TO 30018
20176 CONTINUE
20177 CALL IOFUNC (INPUT,STMT,NS)
      IF (EOF) GO TO 20178
      LJUNK = SCANER (SCAN,STMT,CC1)
      COMMNT=MORE .AND. CCMORE.EQ.1 .AND. BYTE.EQ.CRZ
      IF (.NOT.(SCANER (FIND,7HINCLUDE,7))) GO TO 20179
      ASSIGN 20182 TO NPR028
      GO TO 30028
20182 GO TO 20180
20179 LJUNK = SCANER (SCAN,STMT,CC7)
      IF (.NOT.(SCANER (FIND,9HGO TO NPR,9))) GO TO 20183
      ASSIGN 20186 TO NPR014
      GO TO 30014
20186 GO TO 20184
20183 ASSIGN 20187 TO NPR015
      GO TO 30015
20187 CONTINUE
20184 CONTINUE
20180 GO TO 20177
20178 GO TO 20006
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Process Directive Statement)
30031 IF (.NOT.(SFLIST)) GO TO 20188
      ASSIGN 20191 TO NPR027
      GO TO 30027
20191 IF (.NOT.(ADELT)) GO TO 20192
      IF (.NOT.(PRETTY)) GO TO 20195
      SFLIST = .FALSE.
      GO TO 20196
20195 SFLIST = F4CLC(2H,L,1,STMT,8,2)
20196 CONTINUE
20192 GO TO 20189
20188 SFLIST = .TRUE.
20189 IF (.NOT.(ADDERR.NE.0)) GO TO 20198
      ASSIGN 20201 TO NPR024
      GO TO 30024
20201 ERRORS = .TRUE.
20198 GO TO 20173
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Process Non-Directive Statement)
30030 DRECTV = .FALSE.
      IF (.NOT.(EXEMPT)) GO TO 20202
      ASSIGN 20205 TO NPR026
      GO TO 30026
20205 GO TO 20203
20202 IF (.NOT.(.NOT.COMMNT)) GO TO 10001
      ASSIGN 20206 TO NPR020
      GO TO 30020
20206 IF (.NOT.(.NOT.XLATED)) GO TO 20207
      ASSIGN 20210 TO NPR027
      GO TO 30027
20210 ASSIGN 20211 TO NPR015
      GO TO 30015
20211 CONTINUE
20207 GO TO 20203
10001 IF (.NOT.(COMMNT)) GO TO 10002
      ASSIGN 20212 TO NPR027
      GO TO 30027
20212 CALL IOFUNC (F4OUT,STMT,NS)
10002 CONTINUE
20203 GO TO NPR030, (20168,20174)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Save SFTRAN Label, If Any)
30021 CALL SAVLBL
      GO TO 20094
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test For Statement Exempt From Further Processing)
30029 LJUNK = SCANER (SCAN,STMT,CC1)
      BLANK=.NOT.MORE
      COMMNT=MORE .AND. CCMORE.EQ.1 .AND. BYTE.EQ.CRZ
      STET=COMMNT .AND. F4CLC(STMT,2,STETCH,1,1)
      NONMBR=MORE .AND. CCMORE.GT.5
      EXEMPT=BLANK .OR. STET
      GO TO 20164
C
1     FORMAT(53H Pass 2 inhibited due to pass 1 errors. See LOG file.)
      END
