      SUBROUTINE  SQUEEZ (CCL,CCR,BUFTXT,LTEXT)
C     (Squeeze)
C     Squeezes blanks out of the current statement between  bytes
C     CCL and  CCR inclusive.   The  resultant packed  string  is
C     placed in BUFTXT.  Its length is returned in LTEXT.
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       F4CLC,       F4MVC
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             F4CLC
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LTEXT,       N
C
      INTEGER             BUFTXT(1),   CCL,         CCR,         I
      INTEGER             LTEXT,       N
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
      N=0
      I=CCL
      N20001=CCR
      GO TO 20002
20001 I=I+1
20002 IF ((N20001-I).LT.0) GO TO 20003
      FND = .NOT.F4CLC(STMT,I,BLANKS,1,1)
      IF (.NOT.(FND)) GO TO 20005
      N=N+1
      CALL F4MVC(STMT,I,BUFTXT,N,1)
20005 CONTINUE
20006 GO TO 20001
20003 LTEXT=N
C
      RETURN
      END
